var api = require("../../utils/api.js");
import { API_SCAN } from '../../const/apiurl'
import { ACTION_GOODS } from '../../const/actioncmd'
import { ACTION_GO_BALANCE } from '../../const/actioncmd'
import { ACTION_REQUEST_GOOD_INFO } from '../../const/actioncmd'
import { ACTION_PRINT_RESULT } from '../../const/actioncmd'
import { ACTION_REPRINT } from '../../const/actioncmd'
import { ACTION_GO_SCAN } from '../../const/actioncmd'
import { ACTION_ON_PAY_SUCCESS } from '../../const/actioncmd'
import { ACTION_ON_PAY_FAILED } from '../../const/actioncmd'
import { ACTION_GO_HOME } from '../../const/actioncmd'
import { ACTION_GET_ACCOUNT } from '../../const/actioncmd'
import { ACTION_DIRECT_PAYMENT } from '../../const/actioncmd'
import { ACTION_CONVERT_COUPON } from '../../const/actioncmd'
import { ACTION_LOGIN_OK } from '../../const/actioncmd'
import { ACTION_REFUND } from '../../const/actioncmd'
import { ACTION_REFUND_SUCCESS } from '../../const/actioncmd'
import { ACTION_REFUND_FAILED } from '../../const/actioncmd'

import { FLOW_IDLE, FLOW_COLLECTIONS, FLOW_REFUND} from '../../const/actioncmd'
Page({
  data: {
    //页面控制相关参数
    pageShow: {
      "home": true,
      "landscan": false,
      "waitoperate": false,
      "payresult": false,
      "operateResult":false
    },
    // 前屏是否完成登录
    isFrontScreenLoginOK:false,
    flowType:"",  //流程类型：用于区分易混淆的流程，以及共同界面使用时用该标识位作为区分
    storeName: "--",
    /**支付结果页相关参数 */
    payFailedReason: "xxxxxxxxxxx",
    isPaySuccess: true,
    payPriceYuan: "--.--",
    printResult: "正在打印小票...",
    isPrinting: false,
    isPrintSuccess: false,
    payPriceFen: 0,
    /**商品扫码页相关参数 */
    
    //是否正在用券
    couponUseing: false,

    //兑换券 0关闭兑换券弹窗 1等待兑换 2.兑换中 3.兑换成功 4.兑换失败
    convertCouponState: 0,
    convertCouponMsg: "兑换失败！无效的兑换码",

    //是否正在用券
    couponUseing: false,
    //0代表弹窗关闭 1代表手动输入条码弹窗 2代表会员 3.收款 4.退款 
    scene: 0,
    //总数量
    totalQuantity: 0,
    //折后价格
    totalPrice: 0.00,
    //折扣
    totalDisc: 0.00,
    goods: [
    ],
    operateSuccess:false,
    operateSuccessRemind:"退款成功",
    operateSuccessDesc:"退款完成！会在1~2个工作日返还到付款账户",
    operateFailedRemind:"退款失败",
    operateFailedDesc:"核销失败！无效的订单码",
  },

  /**跳转页面方法 */
  goPage(pageName) {
    var pageShowTemp = {
      "home": false,
      "landscan": false,
      "waitoperate": false,
      "payresult": false,
      "operateResult":false,
    };
    //遍历pageShow
    for (var key in pageShowTemp) {
      if (key == pageName) {
        pageShowTemp[key] = true;
      } else {
        pageShowTemp[key] = false;
      }
    }
    this.setData({
      pageShow: pageShowTemp
    });
  },


  onLoad(query) {
    // 页面加载
    console.info(`Page onLoad with query: ${JSON.stringify(query)}`);
    
  },
  onReady() {
    // 页面加载完成
  },
  onShow() {
    // 页面显示
    let context = this;
    //开启后屏监听
    my.ix.onBuddyMessage({
      success: (res) => {
        console.info(`onBuddyMessage success: ${JSON.stringify(res)}`);

        if (res.action == ACTION_PRINT_RESULT && context.data.pageShow['payresult'] == true) {
          //获取到打印结果
          var printResultData = res.data;
          if (printResultData.code == 0) {
            //打印成功
            context.setData({
              isPrintSuccess: true,
              isPrinting: false,
              printResult: "打印成功"
            });
          } else {
            //打印失败
            context.setData({
              isPrintSuccess: false,
              isPrinting: false,
              printResult: "打印失败"
            });
          }
        } else if (res.action == ACTION_GO_HOME) {
          //重制打印状态
          this.setData({
            isPrinting: true,
            printResult: "正在打印...",
            payPriceYuan: "--.--",
            payPriceFen: 0
          });
          //跳首页
          context.goPage('home');
          setData({
            flowType: FLOW_IDLE,
          })
        } else if (res.action == ACTION_GOODS) {
          //商品信息同步
          my.hideLoading();
          let viewGoodsInfo = res.data
          if (viewGoodsInfo.goods != null && viewGoodsInfo.goods.length > 0) {
            context.setData({
              goods: viewGoodsInfo.goods,
              totalPrice: viewGoodsInfo.totalPrice,
              totalQuantity: viewGoodsInfo.totalQuantity,
              totalDisc: viewGoodsInfo.totalDisc,
            })
          }
        } else if (res.action == ACTION_GO_SCAN) {
          //跳转到
          context.goPage('landscan');
        } else if (res.action == ACTION_GO_BALANCE) {
          //跳转
           context.goPage('waitoperate');
        } else if (res.action == ACTION_ON_PAY_SUCCESS) {

          //分转元
          var miyapay = require("/utils/miyapay4.js");

          context.setData({
            isPaySuccess: true,
            payPriceFen: res.data.tradeAmount,
            payPriceYuan: miyapay.fen2Yuan(res.data.tradeAmount) + "",
          });
          context.goPage('payresult');
        } else if (res.action == ACTION_ON_PAY_FAILED) {

          context.setData({
            isPaySuccess: false,
          });

          context.goPage('payresult');
        } else if (res.action == ACTION_GET_ACCOUNT) {
          context.setData({
            storeName: res.data.storeName
          });
        }else if(res.action == ACTION_DIRECT_PAYMENT){
           //直接收款
           if(res.data != null){
             context.setData({totalPrice:res.data})
           }
           context.goPage('waitoperate');
        }else if(res.action == ACTION_CONVERT_COUPON){
           //兑换券
           context.setData({convertCouponState:res.data.state}) 
           if(null != res.data.msg){
               context.setData({convertCouponMsg:res.data.msg})
           }
        }else if(res.action == ACTION_LOGIN_OK){
          //前屏登录完成
           context.setData({isFrontScreenLoginOK:true})
        } else if(res.action == ACTION_REFUND_SUCCESS){
          //跳转到成功页面
          context.goPage('operateResult');

        } else if(res.action == ACTION_REFUND_FAILED) {
          context.setData({
            isPaySuccess: false,
          });
          context.goPage('operateResult');
        }
        
      }
    });

  },
  onHide() {
    // 页面隐藏
    //关闭后屏监听
    my.ix.offBuddyMessage();
  },
  onUnload() {
    // 页面被关闭
  },
  onTitleClick() {
    // 标题被点击
  },
  onPullDownRefresh() {
    // 页面被下拉
  },
  onReachBottom() {
    // 页面被拉到底部
  },


  onShareAppMessage() {
    // 返回自定义分享信息
    return {
      title: 'My App',
      desc: 'My App description',
      path: 'pages/index/index',
    };
  },

  getAccountInfo() {
    my.ix.sendBuddyMessage({
      target: getApp().globalData.frontScreenAppId,
      data: {
        action: ACTION_GET_ACCOUNT,
        data: null
      },
      success: (res) => {
        console.log("发送收银事件到前屏小程序 成功 ===》" + JSON.stringify(res));
      },
      fail: (res) => {
        console.log("发送收银事件到前屏小程序 失败 ===》 " + JSON.stringify(res));
      },
    });
  },

  /**首页相关 */
  /**立即收款 */
  onHomeCashierImmediatelyClicked() {
     this.setData({scene:3}) 
  },

  /**
   * 兑换
   */
  onHomeExchangeClicked() {
     this.setData({convertCouponState:1})
     this.sendConvertCouponToFront(1)
  },

  /**
   * 海报
   */
  onHomePosterClicked() {

  },

  /**
   * 退款
   */
  onHomeRefundClicked() {
    this.setData({
      flowType :FLOW_REFUND,
      scene:4
    })
    console.log("scene:"+this.data.scene)
  },

  /**
   * 打印上一单
   */
  onHomePrintLastOrderClicked() {

  },

  /**
   * 核验
   */
  onHomeVerifyClicked() {

  },

  /**
   * 提货
   */
  onHomePickUpGoodsClicked() {

  },

  /**日结 */
  onHomeDayCheckClicked() {

  },

  /**关于系统(实际上是关于应用) */
  onHomeAboutAppClicked() {

  },

  /**
   * 系统设置
   */
  onHomeSysSettingClicked() {

  },

  /**
   * 应用设置
   */
  onHomeAppSettingClicked() {

  },

  /**payresult页面逻辑方法 */
  onReprint() {
    //通知前屏重新打印
    my.ix.sendBuddyMessage({
      // 填入目标小程序的 AppID
      target: getApp().globalData.frontScreenAppId,
      data: {
        action: ACTION_REPRINT,
        data: null
      },
      success: (res) => {
        console.info(`sendBuddyMessage success: ${JSON.stringify(res)}`);
      },
      fail: (res) => {
        console.info(`sendBuddyMessage failed: ${JSON.stringify(res)}`);
      }
    });
  },

  onNextPayFromPayResult() {
    //通知前屏跳首页
    my.ix.sendBuddyMessage({
      target: getApp().globalData.frontScreenAppId,
      data: {
        action: ACTION_GO_HOME,
        data: null
      },
      success: (res) => {

        console.log("发送收银事件到前屏小程序 成功 ===》" + JSON.stringify(res));
      },
      fail: (res) => {
        console.log("发送收银事件到前屏小程序 失败 ===》 " + JSON.stringify(res));

      },
    });
  },

  //跳转到收银页面
  sendGoToCollections() {
    var commonRequest = {
      action: ACTION_GO_SCAN,
      data: null
    };
    my.ix.sendBuddyMessage({
      target: getApp().globalData.frontScreenAppId,
      data: commonRequest,
      success: (res) => {
        flowType = FLOW_COLLECTIONS;
        console.log("发送收银事件到前屏小程序 成功 ===》" + JSON.stringify(res));
      },
      fail: (res) => {
        flowType = FLOW_IDLE;
        console.log("发送收银事件到前屏小程序 失败 ===》 " + JSON.stringify(res));
        //发送失败重试
        // context.sendGoToCollections();
        console.log("发送收银事件到前屏小程序 ===》" + JSON.stringify(res));
      },
    });
  },

 
  //发生直接收银事件
  sendPaymentToFront(payment) {
    var commonRequest = {
      action: ACTION_DIRECT_PAYMENT,
      data: payment
    };
    let context = this;
    my.ix.sendBuddyMessage({
      target: getApp().globalData.frontScreenAppId,
      data: commonRequest,
      success: (res) => {
        console.log("发送直接收款事件到前屏小程序 成功 ===》" + JSON.stringify(res));
      },
      fail: (res) => {
        console.log("发送收款事件到前屏小程序 失败 ===》 " + JSON.stringify(res));
        my.showToast({
          type: 'fail',
          content: '操作失败',
          duration: 3000,
          success: () => {
          },
        });
      },
    });
  }, 

  /**landscan页面逻辑方法 */
  //把所有的商品数据发送到后屏
  sendGoodInfoToFront() {
    let context = this;
    var commonRequest = {
      action: ACTION_GOODS,
      data: this.data
    };
    my.ix.sendBuddyMessage({
      target: getApp().globalData.frontScreenAppId,
      data: commonRequest,
      success: (res) => {
        console.log("发送商品数据到前屏小程序成功 ===》" + JSON.stringify(res));
      },
      fail: (res) => {
        console.log("发送商品数据到前屏小程序 失败 ===》 " + JSON.stringify(res));
        //发送失败重试
        context.sendGoodInfoToFront();
      }
    })
  },


  //键盘完成
  onKeyBordFinished(result) {
    if(this.data.scene == 3){
        this.sendPaymentToFront(result)
    }else if(this.data.scene == 1){
        this.sendGoodsInfoToFront(result) 
    }else if(this.data.scene ==4){
      this.sendRefund(result);
      return;
    }
    this.onKeyBordClose();
  },
  
  //把手输条码发生到前屏
  sendGoodsInfoToFront(barcode) {
    my.showLoading({});
    var commonRequest = {
      action: ACTION_REQUEST_GOOD_INFO,
      data: barcode
    };
    my.ix.sendBuddyMessage({
      target: getApp().globalData.frontScreenAppId,
      data: commonRequest,
      success: (res) => {
        console.log("发送商品条码到前屏小程序成功 ===》" + JSON.stringify(res));
      },
      fail: (res) => {
        console.log("发送商品条码到前屏小程序 失败 ===》 " + JSON.stringify(res));
        my.hideLoading();
        my.showToast({
          type: 'fail',
          content: '操作失败',
          duration: 3000,
          success: () => {
          },
        });
      }
    })
  },



  //  键盘关闭
  onKeyBordClose() {
    this.setData({ scene: 0 })
  },

  // 手动输入码
  manualBarcode(e) {
    this.setData({ scene: 1 })
  },

  //清空商品信息
  clearGood(e) {
    this.setData({ goods: [] })
    this.calculation([]);
  },

  //删除商品
  deleteGood(e) {
    let barcode = e.target.id;
    let lastgoods = this.data.goods;
    let newGoods = []
    lastgoods.forEach(function (item, index, array) {
      if (barcode != item.barcode) {
        newGoods.push(item);
      }
    })
    this.setData({ goods: newGoods })
    this.calculation(newGoods);

  },
  //减少商品
  decreaseGood(e) {

    let barcode = e.target.id;
    let lastgoods = this.data.goods;
    let newGoods = []
    lastgoods.forEach(function (item, index, array) {
      if (barcode == item.barcode) {
        if (item.quantity != 1) {
          let quantitytemp = item.quantity
          item.quantity = quantitytemp - 1
          newGoods.push(item);

        }
      } else {
        newGoods.push(item);
      }
    })
    this.setData({ goods: newGoods })
    this.calculation(newGoods);

  },
  //增加商品
  increaseGood(e) {
    console.log(e);
    let barcode = e.target.id;
    let lastgoods = this.data.goods;
    let newGoods = []
    lastgoods.forEach(function (item, index, array) {
      if (barcode == item.barcode) {
        let quantitytemp = item.quantity
        item.quantity = quantitytemp + 1
        newGoods.push(item);
      } else {
        newGoods.push(item);
      }
    })
    this.setData({ goods: newGoods })
    this.calculation(newGoods);
  },


  //计算总价格  总数量  总优惠
  calculation(goods) {
    let quantitytemp = 0;
    let pricetemp = 0;
    goods.forEach(function (item, index, array) {
      quantitytemp = quantitytemp + item.quantity
      pricetemp = pricetemp + item.price * item.quantity
    })
    this.setData({ totalQuantity: quantitytemp, totalPrice: pricetemp })
    //数据同步到前屏
    this.sendGoodInfoToFront()
  },

  //跳转到结算等待页
  goPay(e) {
    var commonRequest = {
      action: ACTION_GO_BALANCE,
      data: ""
    };
    my.ix.sendBuddyMessage({
      target: getApp().globalData.frontScreenAppId,
      data: commonRequest,
      success: (res) => {
        console.log("通知前屏跳转到结算页面 成功 ===》" + JSON.stringify(res));
      },
      fail: (res) => {
        console.log("通知前屏跳转到结算页面 失败 ===》 " + JSON.stringify(res));
        my.showToast({
          type: 'fail',
          content: '结算失败',
          duration: 3000,
          success: () => {
          },
        });
      }
    })
  },

  waitOperateBack() {
    //直接返回到扫码页面，并且通知前屏返回
    this.goPage('landscan');

    my.ix.sendBuddyMessage({
      target: getApp().globalData.frontScreenAppId,
      data: {
        action: ACTION_GO_SCAN,
        data: null
      },
      success: (res) => {
        console.log("通知前屏跳转到结算页面 成功 ===》" + JSON.stringify(res));
      },
      fail: (res) => {
        console.log("通知前屏跳转到结算页面 失败 ===》 " + JSON.stringify(res));
        my.showToast({
          type: 'fail',
          content: '结算失败',
          duration: 3000,
          success: () => {
          },
        });
      }
    })
  },



//兑换券界面关闭
 convertCouponClose(e){
    this.setData({convertCouponState:0})
    this.sendConvertCouponToFront(0)
 },


 //发生兑换券到前屏
 sendConvertCouponToFront(res){
    let context = this;
    my.ix.sendBuddyMessage({
      target: getApp().globalData.frontScreenAppId,
      data: {
        action:ACTION_CONVERT_COUPON,
        data:res
      },
      success: (sres) => {
        console.log("兑换券通知前屏 成功 ===》" + JSON.stringify(sres));
      },
      fail: (fres) => {
        console.log("兑换券通知前屏 失败 ===》 " + JSON.stringify(fres));
        context.sendConvertCouponToFront(res) 
      }
    })
 },

  //用券返回
  couponBack(e) {
    this.setData({ couponUseing: false })
  },
  //使用券
  useCoupon(e) {
    this.setData({ couponUseing: true })
  },
  
  //发送退款金额.以分为单位
  sendRefund(amount){
    var miyapay = require("/utils/miyapay4.js");
    var refundAmount = miyapay.yuan2Fen(amount);
    console.log("amount"+refundAmount);
    my.ix.sendBuddyMessage({
        target: getApp().globalData.frontScreenAppId,
        data:{
          action: ACTION_REFUND,
          data: refundAmount
        },
        success:(res)=>{
          //成功发送则
          console.log("发送退款金额到前屏小程序成功 ===》" + JSON.stringify(res));
        },
        fail:(res)=>{
          my.showToast({
            type: 'fail',
            content: '发送退款金额到前屏失败',
            duration: 3000,
            success: () => {
            },
          });
        }
      })
  }
});
